require "import"
import "android.media.*"
import "java.io.File"
import "android.os.*"
import "android.content.*"
import "android.net.*"
import "android.widget.Button"
import "android.widget.LinearLayout"
import "android.view.View"
import "com.androlua.*"

local vibrator = this.getSystemService(this.VIBRATOR_SERVICE)
if vibrator then vibrator.vibrate(100) end

local folderPath = Environment.getExternalStorageDirectory().getAbsolutePath().."/مسجل الصوت الحصري/"
local file = File(folderPath)
if not file.exists() then success = file.mkdirs() end

function playMusic(player)
    if mp then
        mp.stop()
        mp = nil
    else
        mp = MediaPlayer()
        mp.setAudioStreamType(AudioManager.STREAM_MUSIC)
        mp.reset()
        mp.setDataSource(player)
        mp.prepare()
        mp.start()
        mp.setOnCompletionListener {
            onCompletion = function()
                mp.release()
                mp = nil
            end
        }
    end
    return true
end

local bitRateNames, bitRateValues = {"32 كيلوبت في الثانية", "64 كيلوبت في الثانية", "96 كيلوبت في الثانية", "128 كيلوبت في الثانية", "160 كيلوبت في الثانية", "192 كيلوبت في الثانية", "256 كيلوبت في الثانية", "320 كيلوبت في الثانية"}, {32000, 64000, 96000, 128000, 160000, 192000, 256000, 320000}
if not service.getSharedData("defaultAudioBitrate") then
    service.setSharedData("defaultAudioBitrate", bitRateValues[1])
end

local dlg = LuaDialog()
dlg.setCancelable(false)
dlg.setTitle("معدل البت")
dlg.setSingleChoiceItems(bitRateNames, table.find(bitRateValues, service.getSharedData("defaultAudioBitrate")) - 1)
dlg.setButton2("حفظ")
dlg.onItemClick = function(l, v, p, i)
    service.setSharedData("defaultAudioBitrate", bitRateValues[i])
    return
end

local focus = service.getText(node)
if focus == "خيارات أخرى" or focus == "المزيد من الخيارات" then
    dlg.show()
    return
end

if mr then
    mr.pause()
    focus2 = this.getText(node)
    appName = this.getAppName(node)
    local dlg = LuaDialog()
    dlg.setTitle("تسجيل متوقف مؤقتاً")
    dlg.setButton("استئناف التسجيل", function()
        mr.resume()
    end)
    dlg.setButton2("إيقاف التسجيل", function()
        mr.stop()
        mr.release()
        mr = nil
        if vibrator then vibrator.vibrate(100) end
        local layout = {
            LinearLayout,
            orientation = "vertical",
            {
                Button,
                text = "تشغيل",
                onClick = function()
                    playMusic(outputFile)
                end
            },
            {
                Button,
                text = "مشاركة",
                onClick = function()
                    this.click({{"<"..focus2.."@"..appName..">9000000$10", function()
                        dlg2.show()
                    end}})
                    service.shareFile(outputFile)
                    dlg2.hide()
                end
            },
            {
                Button,
                text = "حذف",
                onClick = function()
                    os.remove(outputFile)
                    service.postSpeak(1200, "تم حذف التسجيل")
                    dlg2.dismiss()
                end
            },
            {
                Button,
                text = "فتح في مدير الملفات",
                onClick = function()
                    this.startActivity(Intent(Intent.ACTION_VIEW).setDataAndType(Uri.parse(folderPath), "resource/folder"))
                    dlg2.dismiss()
                end
            },
            {
                Button,
                text = "تعليمات",
                onClick = function()
                    print("قم بتشغيل هذا الامتداد على التركيز على خيارات أخرى أو المزيد من الخيارات أو ما يشابهها لاختيار جودة التسجيل.")
                    print("للتسجيل، قم بتشغيل هذا الامتداد على أي تركيز آخر غير المذكور أعلاه.")
                    print("لإيقاف التسجيل مؤقتًا، قم بتشغيل هذا الامتداد مرة أخرى وسيوفر خيارات للاستمرار أو إيقاف التسجيل المتوقف مؤقتًا.")
                    print("ملاحظة: تأكد من أن التركيز الأخير قبل إيقاف التسجيل هو الشاشة الرئيسية.")
                    print("لذلك يمكن أن يظهر مربع الحوار للاختيار مرة أخرى بعد مشاركة ملف التسجيل والعودة إلى الشاشة السابقة.")
                    print("تم الإنشاء بواسطة: Solehudin. تم التعديل بواسطة: Ari Joe، وتم الترجمة بواسطة، Ismail Memon.")
                    print("انضم إلى قناتنا على Telegram للحصول على محتوى مفيد آخر!\nhttps://t.me/Jieshuo_source")
                end
            }
        }
        dlg2 = LuaDialog(this)
        dlg2.View = loadlayout(layout)
        dlg2.setCancelable(false)
        dlg2.setTitle("النتيجة "..fileName)
        dlg2.setButton2("إغلاق")
        dlg2.onDismiss = function()
            appName = nil
            focus2 = nil
            fileName = nil
            layout = nil
            dlg2 = nil
            this.playSoundGestureEnd()
        end
        dlg2.show()
    end)
    dlg.setButton3("إخفاء الحوار")
    dlg.show()
    this.postClick(500, {{"<إيقاف التسجيل"}})
else
    if fileName == nil then
        fileName = os.date("تسجيل_%Y_%m_%d_%H_%M_%S.mp3")
        this.playSoundGestureBegin()
    end
    outputFile = folderPath..fileName
    mr = MediaRecorder()
    mr.setAudioSource(MediaRecorder.AudioSource.MIC)
    mr.setOutputFormat(MediaRecorder.OutputFormat.MPEG_4)
    mr.setAudioEncoder(MediaRecorder.AudioEncoder.AAC)
    mr.setAudioEncodingBitRate(service.getSharedData("defaultAudioBitrate"))
    mr.setOutputFile(outputFile)
    mr.prepare()
    mr.start()
end